#ifndef PTX_MISC
#define PTX_MISC

#include <sys/uio.h>

#define ARRAY_SIZE(_x)		(sizeof(_x) / sizeof((_x)[0]))

#define PTX_POW_OF_TWO(_x)	(!((_x) & ((_x) - 1)))


static inline size_t iov_length(const struct iovec *iov, unsigned long nr_segs)
{
        unsigned long seg;
	size_t ret = 0;
 
	for (seg = 0; seg < nr_segs; seg++)
		ret += iov[seg].iov_len;
	return ret;
}


#ifndef MAX
#define MAX(x,y)	((x) > (y) ? (x) : (y))
#endif
#ifndef MIN
#define MIN(x,y)	((x) < (y) ? (x) : (y))
#endif

#define LEVEL_ALL	7
#define LEVEL_DEBUG	6
#define LEVEL_INFO	5
#define LEVEL_NOTICE	4
#define LEVEL_WARN	3
#define LEVEL_ERROR	2
#define LEVEL_CRIT	1

#ifdef DEBUG
#define dprintf(_level, _fmt, _arg...)			\
do {							\
	if (_libgsloop_debuglevel >= (_level)) {	\
		fprintf(stdout,(_fmt), ##_arg);		\
		fflush(stdout);				\
	}						\
} while (0)
#else
#define dprintf(_level, _fmt, _arg...)			\
do { } while (0)
#endif

extern int _libgsloop_debuglevel;

#define ptx_alloc(_type)	(_type *)calloc(1, sizeof(_type))

#endif
